import { csvParse, select, sum, min, max, extent, group, flatGroup, rollup, flatRollup, bin } from 'd3';

export const viz = (
  container,
  { state, setState }
) => {
  
  if(state.data && state.data !== 'LOADING'){
   	const data = state.data;
//    	console.log(data.filter(d => d.species === "versicolor"));
//     // console.log(data.map(d => d.petal_length))
// 		const speciesSet = new Set(data.map(d => d.species))

//     console.log(Array.from(speciesSet))
    // console.log(min(data, (d => d.petal_length)))
    // console.log(max(data, (d => d.petal_length)))
    // console.log(extent(data, (d) => d.petal_length))
    // console.log(flatRollup(data,v => sum(v, d => d.sepal_length)/v.length, d => d.species
    //                   ).map(([species, avg])=> ({species, avgSepalLength: avg}))
    //            )
    console.log(bin()(data.map(d => d.sepal_length)).map(v => ({
    	x0: v.x0,
      x1: v.x1,
      count: v.length
    })))
  }
  
  select(container)
    .selectAll('pre')
    .data([null])
    .join('pre')
    .text(JSON.stringify(state.data, null, 2));
 
  // state.data could be:
  // * undefined
  // * 'LOADING'
  // * An array of objects
  const { data } = state;

  if (data === undefined) {
    setState((state) => ({
      ...state,
      data: 'LOADING',
    }));
    fetch('data.csv')
      .then((response) => response.text())
      .then((csvString) => {
        const data = csvParse(csvString);
      
        for (const d of data) {
          d.petal_length = +d.petal_length;
          d.petal_width = +d.petal_width;
          d.sepal_length = +d.sepal_length;
          d.sepal_width = +d.sepal_width;
        }
      
        setState((state) => ({
          ...state,
          data,
        }));
      });
  }
};
